#include <stdio.h>
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Input.H>
#include <FL/names.h>
#include <FL/x.H>

int debugEventDispatch(const int event, Fl_Window *window) {
  printf("Event: %s (%d)", fl_eventnames[event], event);
  if (window != NULL) {
    printf("  fl_xid(window) %d", fl_xid(window));
  }
  printf("\n");

  return Fl::handle_(event, window);
}

int debugSystemHandler(void* event, void* data) {
  if (event != NULL) {
    XEvent* systemEvent = reinterpret_cast<XEvent*>(event);

    switch (systemEvent->type) {
    case (KeyPress):
      printf("XEvent: KeyPress  ");
      {
        XKeyEvent* systemKeyEvent = reinterpret_cast<XKeyEvent*>(systemEvent);
        printf("XEvent: Window %d\n", systemKeyEvent->window);
      }

      break;
    case (KeyRelease):
      printf("XEvent: KeyPress  ");
      {
        XKeyEvent* systemKeyEvent = reinterpret_cast<XKeyEvent*>(systemEvent);
        printf("XEvent: Window %d\n", systemKeyEvent->window);
      }

      break;
    }
  }

  return 0;
}

class MyWindow : public Fl_Window
{
public:
 MyWindow(int w, int h, const char *l=0) : Fl_Window(w,h,l)	{}
 void show() {
   Fl_Window::show();

   // Fl_Window::wait_for_expose(); // uncomment this for "improved" behavior
  }
};

void exit_cb(Fl_Widget *,void *) {
  exit(0);
}

int main(int argc, char **argv) {
  for (int win = 0; win < 3; win++) {
    Fl_Window *window = new MyWindow(400,420);

    int y = 10;
    new Fl_Input(70,y,300,30,"Input1:"); y += 35;
    new Fl_Input(70,y,300,30,"Input2:"); y += 35;

    window->end();
    window->callback(exit_cb);
    window->show(argc,argv);
  }

  // Fl::add_system_handler (debugSystemHandler, NULL); // Uncomment both lines to see
  // Fl::event_dispatch (debugEventDispatch);           // lack of event propagation

  return Fl::run();
}
